function embuttonsOpenExtensions(aOpenMode)
{

 const OPEN_WINDOW = 0;
 const OPEN_TAB = 1;
 const OPEN_SIDEBAR = 2;
 const EMTYPE = "Extension:Manager";
 const EMFEATURES = "chrome,dialog=no,resizable";
 const EMURL = "chrome://mozapps/content/extensions/extensions.xul?type=" + aOpenMode;

 try {
var openinPref = (aOpenMode == 'extensions') ? (gPref.getIntPref("extensions.embuttons.extensionsTarget")) : (gPref.getIntPref("extensions.embuttons.themesTarget"));
var panelTitle = (aOpenMode == 'extensions') ? "Extensions" : "Themes";

     var sortPref = (gPref.getBoolPref("extensions.embuttons.alphasortEM"));
 } catch(e){}

  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);
  var needToOpen = true;
  var windowType = EMTYPE + "-" + aOpenMode;
  var windows = wm.getEnumerator(windowType);
  while (windows.hasMoreElements()) {
    var theEM = windows.getNext().QueryInterface(Components.interfaces.nsIDOMWindowInternal);
    if (theEM.document.documentElement.getAttribute("windowtype") == windowType) {
      theEM.focus();
      needToOpen = false;
      break;
    }
  }

  if (needToOpen) {
    if ((sortPref) && (aOpenMode == 'extensions')) SortExtensionsBy('name');
    switch (openinPref) {
      case OPEN_WINDOW :
        window.openDialog(EMURL, "", EMFEATURES);
        break;
      case OPEN_TAB :
        openNewTabWith(EMURL);
        break;
      case OPEN_SIDEBAR :
        openWebPanel(panelTitle,EMURL);
        break;
    }
  }

}


function SortExtensionsBy(aProp)
{
  var sortTarget=function(aResource,aSortProperty)
  {
    this.resource=aResource;
    this.prop=aSortProperty;
    this.toString=function(){return this.prop;};
  };

  var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
               .getService(Components.interfaces.nsIRDFService);
  var Container = Components.classes["@mozilla.org/rdf/container;1"]
               .getService(Components.interfaces.nsIRDFContainer);

  var extensionDS= Components.classes["@mozilla.org/extensions/manager;1"]
  .getService(Components.interfaces.nsIExtensionManager).datasource;
  var root=RDFService.GetResource("urn:mozilla:extension:root");
  var arc=RDFService.GetResource("http://www.mozilla.org/2004/em-rdf#"+aProp);
  Container.Init(extensionDS,root);

  var elements=Container.GetElements();
  var sortArray=[];
  try{
    while(elements.hasMoreElements())
    {
      var element=elements.getNext();
      var prop="";
      element.QueryInterface(Components.interfaces.nsIRDFResource);
      var target=extensionDS.GetTarget(element, arc ,true);
      if(target)
        prop=target
          .QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
      sortArray.push(new sortTarget(element,prop));
      Container.RemoveElement(element,false);
    }
  }catch(e){}
  sortArray.sort();
  for(var i in sortArray)
    Container.AppendElement(sortArray[i].resource)

  extensionDS.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
  extensionDS.Flush();
}
